//Below is the 78 chars line!
//----------------------------------------------------------------------------
//Jason Winnebeck

#ifndef _WINDOW_H_
#define _WINDOW_H_

#include <strstream.h>
#include <allegro.h>

const int MSG_TEXTBOX = MSG_USER;
  //simply remap for better readability

int editWrapper(int msg, DIALOG* d, int c);
  //Sends MSG_TEXTBOX (or MSG_USER) to whole dialog when user presses enter
  // in the editbox.  IT CLEARS THE BOX IMMEDIATELY, without modifying the
  // data by simply drawing a blank editbox, this is to assume the program
  // will handle the data, and truly clear it (or NULL terminate the buffer)
  // during the MSG_TEXTBOX call.
  //Since it broadcasts messages itself (since Allegro's GUI system forces it
  // to), it has to return D_USED_CHAR.  The only thing that will pass through
  // is D_CLOSE, because if the dialog closes it doesn't matter if the char
  // was used.  The only other reasonable return is D_REDRAW, and I'm not
  // sure how to handle that.

void QOutput(char* msg);

class QTextBox {
public:
  QTextBox();
  ~QTextBox();

  void Clear(); //Clears the text
  static int  do_QTextBox(int msg, DIALOG* d, int c);
                //this goes in the dialog

  //Output
  QTextBox& operator << (char ch);
  QTextBox& operator << (const char* str);
  QTextBox& operator << (short x);
  QTextBox& operator << (int x);
  QTextBox& operator << (long x);
  QTextBox& operator << (double x);

  QTextBox& operator << (ostrstream* &out);//Displays text in window
private:
  int doWin(int msg, DIALOG* d, int c);

  bool changed;

  ostrstream *text;
};

class QInput {
public:
  QInput();
  QInput(const char* newTitle, const char* newPrompt);
    //Same as SetInfo, but at creation
  ~QInput();

  void SetInfo(const char* newTitle, const char* newPrompt);
    //pass NULL as a parameter to not change something

  QInput& operator >> (short &x);
  QInput& operator >> (int &x);
  QInput& operator >> (long &x);
  QInput& operator >> (char* str);
    //Assumes str has space to hold data
  QInput& operator >> (float &x);
  QInput& operator >> (double &x);

  static int inputController(int msg, DIALOG* d, int c);
    //Dialog function to monitor for MSG_TEXTBOX
private:
  void CreateDialog();
    //Fills in dialog x,y,w,h based on string data and font size
  void DoDialog();
    //Performs main action

  char* title;
  char* prompt;
  char* buf;

  //x,y,w,h values are dynamically calculated, based on size of title/prompt
  // and the font size (uses font pointer like all other GUI routines)
  DIALOG* QInputGUI;
};

#endif
