#include "qgui.h"
#include <string.h>
#include <tdgui.h>
#include <allegro.h>
#include <stdlib.h>

//This is weird so I can use this on the initalizer instead of worring about
// new and all dat
const int baseDialogSize = 6;
const DIALOG baseDialog[] = {
  /* (dialog proc)       (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
  {d_billwin_proc,        0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL},
  {d_billctext_proc,      0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL},
  {editWrapper,           0,    0,    0,    0,     0,  0,    0,        0,  128,    0,  NULL},
  {d_billbutton_proc,     0,    0,    0,    0,     0,  0,    0,   D_EXIT,    0,    0,  (void*)"OK"},
  {QInput::inputController,0,   0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL},
  {NULL,                  0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL}
};

//indexes of objects for use in CreateDialog()
const int THE_WINDOW = 0;
const int THE_PROMPT = 1;
const int THE_EDITBOX = 2;
const int THE_BUTTON = 3;

//Minimum reasonable width
const int MIN_WIDTH = 128;

QInput::QInput() {
  title = strdup("No Title");
  prompt = strdup("No Prompt");
  buf = new char[128];
  buf[0] = '\0';

  QInputGUI = new DIALOG[baseDialogSize];
  memcpy((void*)QInputGUI, (void*)baseDialog, sizeof(DIALOG) * baseDialogSize);
  QInputGUI[THE_EDITBOX].dp = (void*)buf;

  //filling is done in CreateDialog()
}

QInput::QInput(const char* newTitle, const char* newPrompt) {
  title = strdup(newTitle);
  prompt = strdup(newPrompt);
  buf = new char[128];
  buf[0] = '\0';

  QInputGUI = new DIALOG[baseDialogSize];
  memcpy((void*)QInputGUI, (void*)baseDialog, sizeof(DIALOG) * baseDialogSize);
  QInputGUI[THE_EDITBOX].dp = (void*)buf;

  //filling is done in CreateDialog()
}

QInput::~QInput() {
  if (title)
    delete[] title;
  if (prompt)
    delete[] prompt;
  if (buf)
    delete[] buf;
  if (QInputGUI)
    delete[] QInputGUI;
}

void QInput::SetInfo(const char* newTitle, const char* newPrompt) {
  //pass NULL as a parameter to not change something
  if (newTitle != NULL) {
    delete[] title;
    title = strdup(newTitle);
  }

  if (newPrompt != NULL) {
    delete[] prompt;
    prompt = strdup(newPrompt);
  }
}

QInput& QInput::operator >> (short &x) {
  DoDialog();
  x = atoi(buf);

  return *this;
}

QInput& QInput::operator >> (int &x) {
  DoDialog();
  x = atoi(buf);

  return *this;
}

QInput& QInput::operator >> (long &x) {
  DoDialog();
  x = atol(buf);

  return *this;
}

QInput& QInput::operator >> (char* str) {
  //Assumes str has space to hold data
  DoDialog();
  strcpy(str, buf);

  return *this;
}

QInput& QInput::operator >> (float &x) {
  DoDialog();
  x = atof(buf);

  return *this;
}

QInput& QInput::operator >> (double &x) {
  DoDialog();
  x = atof(buf);

  buf[0] = '\0'; //Clear textbox
  return *this;
}

int QInput::inputController(int msg, DIALOG* d, int c) {
  if (msg == MSG_TEXTBOX) {
    return D_CLOSE;
  } else
    return D_O_K;
}

void QInput::CreateDialog() {
  //find widest point
  int maxwidth = text_length(font, prompt);
  if (text_length(font, title) > maxwidth)
    maxwidth = text_length(font, title);
  if (MIN_WIDTH > maxwidth)
    maxwidth = MIN_WIDTH;

  maxwidth += 32;      //give a nice 16 pixel border

  //The x,y,w, and h need to be reset to zero since those "invisible" objs
  // also move too.
  for (int c=0; c<baseDialogSize; c++)
    QInputGUI[c].w = QInputGUI[c].h = QInputGUI[c].x = QInputGUI[c].y = 0;

  //Start calculating
  QInputGUI[THE_WINDOW].w = maxwidth;
  QInputGUI[THE_PROMPT].x = maxwidth / 2;
  QInputGUI[THE_PROMPT].y = text_height(font) + 16;
  QInputGUI[THE_PROMPT].h = text_height(font);
    //Give a 16 pixel border below the title
  QInputGUI[THE_EDITBOX].w = maxwidth * 2 / 3;
  QInputGUI[THE_EDITBOX].x = (maxwidth / 2) - (QInputGUI[THE_EDITBOX].w / 2);
    //Place in center, 2/3 maxwidth width
  QInputGUI[THE_EDITBOX].y = QInputGUI[THE_PROMPT].y + QInputGUI[THE_PROMPT].h + 4;
  QInputGUI[THE_EDITBOX].h = 4 + text_height(font);
    //4 space, one row of text plus room to draw box
  QInputGUI[THE_BUTTON].y = QInputGUI[THE_EDITBOX].y + QInputGUI[THE_EDITBOX].h + 8;
  QInputGUI[THE_BUTTON].h = 8 + text_height(font);
    //8 space, one row of text to draw box
  QInputGUI[THE_BUTTON].w = text_length(font, (char*)QInputGUI[THE_BUTTON].dp) + 8;
  QInputGUI[THE_BUTTON].x = (maxwidth / 2) - (QInputGUI[THE_BUTTON].w / 2);
    //Size button corretly and give padding
  QInputGUI[THE_WINDOW].h = QInputGUI[THE_BUTTON].y + QInputGUI[THE_BUTTON].h + 8;
    //Give 8 padding before bottom of window

  //Update strings -- update pointers!
  QInputGUI[THE_WINDOW].dp = (void*)title;
  QInputGUI[THE_PROMPT].dp = (void*)prompt;
}

void QInput::DoDialog() {
  buf[0] = '\0'; //Clear textbox
  CreateDialog();
  centre_dialog(QInputGUI);
  init_moveable(QInputGUI);
  do_dialog (QInputGUI, THE_EDITBOX);
  shutdown_moveable(QInputGUI);
}
